"use client"

import { useRouter } from "next/navigation"
import { useTransition } from "react"
import { Form as FormRAC } from "react-aria-components"
import { useFormContext } from "react-hook-form"

import { REDEMPTION } from "@/constants/booking"
import { selectHotel, selectRate } from "@/constants/routes/hotelReservation"

import useLang from "@/hooks/useLang"
import { serializeBookingSearchParams } from "@/utils/url"

import FormContent, { BookingWidgetFormContentSkeleton } from "./FormContent"
import { bookingWidgetVariants } from "./variants"

import styles from "./form.module.css"

import type {
  BookingWidgetSchema,
  BookingWidgetType,
} from "@/types/components/bookingWidget"
import type { BookingWidgetFormProps } from "@/types/components/form/bookingwidget"

const formId = "booking-widget"

export default function Form({ type, onClose }: BookingWidgetFormProps) {
  const router = useRouter()
  const lang = useLang()
  const [isPending, startTransition] = useTransition()

  const classNames = bookingWidgetVariants({
    type,
  })

  const { handleSubmit, setValue, reset } =
    useFormContext<BookingWidgetSchema>()

  function onSubmit(data: BookingWidgetSchema) {
    const bookingFlowPage = data.hotel ? selectRate(lang) : selectHotel(lang)
    const bookingWidgetParams = serializeBookingSearchParams({
      rooms: data.rooms,
      ...data.date,
      ...(data.city ? { city: data.city } : {}),
      ...(data.hotel ? { hotel: data.hotel } : {}),
      ...(data.bookingCode?.value
        ? { bookingCode: data.bookingCode.value }
        : {}),
      // Followed current url structure to keep searchtype=redemption param incase of reward night
      ...(data.redemption ? { searchType: REDEMPTION } : {}),
    })

    onClose()
    startTransition(() => {
      router.push(`${bookingFlowPage}?${bookingWidgetParams.toString()}`)
    })
    if (!data.bookingCode?.value) {
      setValue("bookingCode.remember", false, {
        shouldDirty: true,
      })
      localStorage.removeItem("bookingCode")
    } else if (data.bookingCode?.remember) {
      localStorage.setItem("bookingCode", JSON.stringify(data.bookingCode))
    }
    reset(data)
  }

  return (
    <section className={classNames}>
      <FormRAC
        onSubmit={handleSubmit(onSubmit)}
        className={styles.form}
        id={formId}
      >
        <FormContent
          formId={formId}
          onSubmit={handleSubmit(onSubmit)}
          isSearching={isPending}
        />
      </FormRAC>
    </section>
  )
}

export function BookingWidgetFormSkeleton({
  type,
}: {
  type: BookingWidgetType
}) {
  const classNames = bookingWidgetVariants({
    type,
  })

  return (
    <section className={classNames}>
      <form className={styles.form}>
        <BookingWidgetFormContentSkeleton />
      </form>
    </section>
  )
}
